#!/usr/bin/perl
# (c) MandrakeSoft, Chmouel Boudjnah <chmouel@mandrakesoft.com>, 
# DindinX (David Odin) <odin@mandrakesoft.com>
# Copyright under GPL blah blah blah.
## Give the string to DrakConf, c is too suck to parse string :).

my $conf_files;
my $xterm = '/usr/X11R6/bin/xterm -fn 9x15 -bg black -fg white -e';

(my $LANG = $ENV{'LANGUAGE'} || $ENV{'LC_ALL'} || $ENV{'LC_MESSAGES'} || $ENV{'LANG'}) =~ s|_.*||;

if ( -r '/etc/sysconfig/system') {
  $expert = cat_("/etc/sysconfig/system") =~ /^TYPE="?expert/m; #";
}

while ($ARGV[0] =~ /^--/ || $ARGV[0] =~ /^-/) {
  $_ = shift;
  if (/^--expert/ || /^-e/) {    
    $expert++;
  } elsif (/^--test/ || /^-t/) {
    $test++;
  } elsif (/^--file=([^ \t]+)/ || /^-f=([^ \t]+)/) {
    $conf_files = $1;
  } else {
    die "Unrecognized switch: $_\n";
  }
}

$conf_files = $test ? './DrakConf.rc' : '/etc/DrakConf.rc' unless $conf_files;

do {print "ERROR = ERROR\n"; exit 1}
  unless -f ($conf_files);

open(FH, $conf_files);

$/="";
while (<FH>) {
  my $program, $icon_name ;
  eval ($1) if /EVAL=(.*)$/m;
  s|\"||g;

  $program=$1 if /PROGRAM=(.*)/ && !$program; (my $t = $program) =~ s| .*||; next unless  -x $t || $test;
  next if /^DANGEROUS=YES/m && !$expert;

  &parse_lang(NAME);
  print "PROGRAM=$program\n";
  $icon_name ? print "ICON_NAME=$icon_name\n" : &parse_entry(ICON_NAME);
  &parse_lang(DESC);
}

close FH;

sub parse_lang {
  my $s = shift @_;
  if (/$s\($LANG\)=(.*)/) { print "$s=$1\n"; } elsif (/$s=(.*)/) { print "$s=$1\n"; }
}

sub parse_entry {
  my $s = shift @_;  print "$s=$1\n"  if /$s=(.*)/; return $1;
}

sub cat_ { local *F; open F, $_[0] or $_[1] ? die "cat of file $_[0] failed: $!\n" : return; my @l = <F>; wantarray ? @l : join '', @l }
